<?php /*
Plugin Name: Bit.ly Exporter
Plugin URI: http://www.seodenver.com/bitly-exporter/
Description: Export your bit.ly link click history.
Author: Katz Web Services, Inc.
Version: 1.0.1
Author URI: http://www.katzwebservices.com

--------------------------------------------------
 
Copyright 2011  Katz Web Services, Inc.  (email : info@katzwebservices.com)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/
add_action('init', array('KWS_BitlyExporter','init'),1);

class KWS_BitlyExporter {
	
	function init() {
		if(is_admin()) {
			global $pagenow;
			$bitlyExporter = new KWS_BitlyExporter();
			if((in_array(basename($_SERVER['PHP_SELF']), array('tools.php')) && isset($_REQUEST['page']) && $_REQUEST['page'] == 'bitlyexporter'))  {
				$plugin_dir = basename(dirname(__FILE__)).'languages';
				load_plugin_textdomain( 'bitlyexporter', 'wp-content/plugins/' . $plugin_dir, $plugin_dir );
			}
		}
	}
	
	function KWS_BitlyExporter() {
    	add_action('admin_menu', array(&$this, 'admin'));
	    add_filter('plugin_action_links', array(&$this, 'settings_link'), 10, 2 );
        add_action('admin_init', array(&$this, 'settings_init') );
    	
    	if(in_array(basename($_SERVER['PHP_SELF']), array('tools.php')) && isset($_REQUEST['page']) && $_REQUEST['page'] == 'bitlyexporter')  {
    			
	    	$this->options = get_option('bitlyexporter', array());
	        
	        // Set each setting...
	        foreach($this->options as $key=> $value) {
	        	$this->{$key} = $value;
	        }
	        
	        if(!empty($this->apikey)) { define('bitlyKey', $this->apikey); }
			if(!empty($this->username)) { define('bitlyLogin' , $this->username); }
			
			include_once('class.bitly.php');
	        
	        if(in_array(basename($_SERVER['PHP_SELF']), array('tools.php')) && isset($_REQUEST['page']) && $_REQUEST['page'] == 'bitlyexporter') {
	        	$this->CheckSettings();
	        	$this->processSubmit();
	        	$this->processDownload();
	        }
		}
    }
    
  	function form_table($rows) {
        $content = '<table class="form-table" width="100%">';
        foreach ($rows as $row) {
            $content .= '<tr><th valign="top" scope="row" style="width:50%">';
            if (isset($row['id']) && $row['id'] != '')
                $content .= '<label for="'.$row['id'].'" style="font-weight:bold;">'.$row['label'].':</label>';
            else
                $content .= $row['label'];
            if (isset($row['desc']) && $row['desc'] != '')
                $content .= '<br/><small>'.$row['desc'].'</small>';
            $content .= '</th><td valign="top">';
            $content .= $row['content'];
            $content .= '</td></tr>'; 
        }
        $content .= '</table>';
        return $content;
    }

    function postbox($id, $title, $content, $padding=false) {
        ?>
            <div id="<?php echo $id; ?>" class="postbox">
                <div class="handlediv" title="Click to toggle"><br /></div>
                <h3 class="hndle"><span><?php echo $title; ?></span></h3>
                <div class="inside" <?php if($padding) { echo 'style="padding:10px; padding-top:0;"'; } ?>>
                    <?php echo $content; ?>
                </div>
            </div>
        <?php
    }
    
    function make_notice_box($content, $type="error") {
        $output = '';
        if($type!='error') { $output .= '<div style="background-color: rgb(255, 255, 224);border-color: rgb(230, 219, 85);-webkit-border-bottom-left-radius: 3px 3px;-webkit-border-bottom-right-radius: 3px 3px;-webkit-border-top-left-radius: 3px 3px;-webkit-border-top-right-radius: 3px 3px;border-style: solid;border-width: 1px;margin: 5px 0px 15px;padding: 0px 0.6em;">';
        } else {
            $output .= '<div style="background-color: rgb(255, 235, 232);border-color: rgb(204, 0, 0);-webkit-border-bottom-left-radius: 3px 3px;-webkit-border-bottom-right-radius: 3px 3px;-webkit-border-top-left-radius: 3px 3px;-webkit-border-top-right-radius: 3px 3px;border-style: solid;border-width: 1px;margin: 5px 0px 15px;padding: 0px 0.6em;">';
        }
        $output .= '<p style="line-height: 1; margin: 0.5em 0px; padding: 2px;">'.$content.'</div>';
        return($output);
    }
    
    private function CheckSettings() {
		$this->configured = bitly_v3_validate($this->username, $this->apikey);
		return $this->configured;
	}
	
	function configuration() { 
		return $html;
    }
    
    function admin() {
        #add_options_page('Bit.ly Exporter', 'Bit.ly Exporter', 'administrator', 'bitlyexporter', array(&$this, 'admin_page'));  
        add_management_page('Bit.ly Exporter', 'Bit.ly Exporter', 'administrator', 'bitlyexporter', array(&$this, 'admin_page'));  
    }
    
	function admin_page() {
        ?>
        <div class="wrap">
        <h2>Bit.ly Exporter</h2>
<?php if($this->configured) { ?>
        <div class="postbox-container" style="width:65%;">
            <div class="metabox-holder">	
                <div class="meta-box-sortables">
                   <?php 
                   		$this->showLinkForm();
                   	?>
                </div>
            </div>
        </div>
        <div class="postbox-container" style="width:34%;">
            <div class="metabox-holder">	
                <div class="meta-box-sortables">
                <?php
                $this->showSettingsForm(); 
                ?>
                </div>
            </div>
        </div>
<?php } else { ?>
	 <div class="postbox-container" style="width:50%;">
        <div class="metabox-holder">	
            <div class="meta-box-sortables">
            <?php
            $this->showSettingsForm(); 
            ?>
            </div>
        </div>
    </div>
<?php } ?>
    </div>
    <?php   
    }
    
    function showSettingsForm() { ?>
     <form action="options.php" method="post">
       <?php 
       		$this->show_configuration_check(false);
        	wp_nonce_field('update-options'); 
            settings_fields('bitlyexporter_options');
       
$rows[] = array(
                    'id' => 'bitlyexporter_username',
                    'label' => __('Bit.ly Username', 'bitlyexporter'),
                    'content' => "<input type='text' name='bitlyexporter[username]' id='bitlyexporter_username' value='".esc_attr($this->username)."' size='40' style='width:95%!important;' />",
                    'desc' => ''
             );
             
/*
             $rows[] = array(
                    'id' => 'bitlyexporter_password',
                    'label' => __('Bit.ly Password (optional)', 'bitlyexporter'),
                    'content' => "<input type='text' name='bitlyexporter[password]' id='bitlyexporter_password' value='".esc_attr($this->password)."' size='40' style='width:95%!important;' />",
                    'desc' => 'The password is only required if you do not have the API key.'
             );
*/
                
            $rows[] = array(
                    'id' => 'bitlyexporter_apikey',
                    'label' => __('API Key', 'bitlyexporter'),
                    'desc' => 'Your Bit.ly API Key',
                    'content' => "<input type='text' name='bitlyexporter[apikey]' id='bitlyexporter_apikey' value='".esc_attr($this->apikey)."' size='40' style='width:95%!important;' />"
            );
            
            if($this->configured) { $name = 'Bit.ly API Settings <span style="color:green">(configured)</span>'; } else { $name = 'Bit.ly API Settings <span style="color:#c00">(not configured)</span>'; }
            $this->postbox('bitlyexportersettings',$name, $this->form_table($rows), false);
             
        ?>

            <p>
            	<input type="hidden" name="page_options" value="<?php foreach($rows as $row) { $output .= $row['id'].','; } echo substr($output, 0, -1);?>" />
            	<input type="hidden" name="action" value="update" />
            	<?php if($this->configured) { ?>
	                <input type="submit" class="button-secondary alignright action" name="save" value="<?php _e('Update Settings', 'bitlyexporter') ?>" />
	            <?php } else { ?>
	            	<input type="submit" class="button-primary action" name="save" value="<?php _e('Update Settings', 'bitlyexporter') ?>" />
	            <?php } ?>
            </p>
        </form>
    <?php 
    } 
    
    
    function showLinkForm() { ?>
    	<form action="<?php echo  admin_url( 'tools.php?page=bitlyexporter' ); ?>" method="post">
       	<?php 
       		if(isset($_POST['link']) && empty($_POST['link'])) {
       			echo $this->make_notice_box('<label for="bitlyexporter_link">You must enter a link.</label>', 'error');
       		}
       		 
       		$disabled = $this->configured ? '' : ' disabled="disabled"';
       		$link = isset($_POST['link']) ? $_POST['link'] : "";
       		$time = isset($_POST['time']) ? $_POST['time'] : 90;
       		$export[] = array(
                    'id' => 'bitlyexporter_link',
                    'label' => __('Bit.ly Link', 'bitlyexporter'),
                    'desc' => 'Use any bit.ly service link, including j.mp or custom links.',
                    'content' => "<label for='bitlyexporter_link'><input type='text' name='link' id='bitlyexporter_link' {$disabled} value='".$link."' size='40' style='width:95%!important;' /> <span class='howto'>You can use either <span class='code'>http://bit.ly/example</span>&nbsp;&nbsp;<span style='color:#555; font-style:normal;'>or</span> <span class='code'>example</span></span></label>"
            );
            
            $export[] = array(
                    'id' => 'bitlyexporter_link',
                    'label' => __('Time Period', 'bitlyexporter'),
                    'desc' => 'How long do you want stats for?',
                    'content' => "
						<label for='bitlyexporter_time' class='howto'>
							<span>Show</span>
							<select name='time' {$disabled} id='bitlyexporter_time'>
								<option id='bitlyexporter_time_days_1095' value='1095'".selected($time, 1095, false).">Three years</option>
								<option id='bitlyexporter_time_days_730' value='730'".selected($time, 730, false).">Two years</option>
								<option id='bitlyexporter_time_days_365' value='365'".selected($time, 365, false).">One year</option>
								<option id='bitlyexporter_time_days_180' value='180'".selected($time, 180, false).">180 days</option>
								<option id='bitlyexporter_time_days_90' value='90'".selected($time, 90, false).">90 days</option>
								<option id='bitlyexporter_time_days_60' value='60'".selected($time, 60, false).">60 days</option>
								<option id='bitlyexporter_time_days_30' value='30'".selected($time, 30, false).">30 days</option>
								<option id='bitlyexporter_time_days_14' value='14'".selected($time, 14, false).">2 weeks</option>
								<option id='bitlyexporter_time_days_7' value='7'".selected($time, 7, false).">1 week</option>
							</select>
							<span>of statistics</span>
						</label>
                    "
            );

            $this->postbox('bitlyexporterexport',__('Export Link History', 'bitlyexporter'), $this->form_table($export), false);
       	?>
       		<p>
               	<?php wp_nonce_field('export_bitly_action','export_bitly_field'); ?>
               	<input type="submit" <?php echo $disabled; ?> class="button-primary" name="export" value="Get Link History" />
            </p>
       	</form>
       	<?php 
       		$this->linkStatsOutput(); 
    }
    
	function processSubmit() {
 		if ( !empty($_POST) && check_admin_referer('export_bitly_action','export_bitly_field') ) {
			extract($_POST);
			
			$this->transientKey = 'bit_'.sha1("{$link}_{$time}");
			
			$data = get_transient($this->transientKey);
			if(!$data) { $data = bitly_v3_clicks_by_day($link, $time); }
			if(empty($data)) { return false; }
			
			foreach($data[0]['clicks'] as $key => $day) {
				$data[0]['clicks'][$key]['date'] = date('m/d/Y',$day['day_start']);
				$data[0]['clicks'][$key]['day_of_week'] = date('l',$day['day_start']);
				$data[0]['clicks'][$key]['week'] = date('W',$day['day_start']);
				$data[0]['clicks'][$key]['month'] = date('m',$day['day_start']);
				$data[0]['clicks'][$key]['year'] = date('Y',$day['day_start']);
			}
			$data[0]['time'] = $time;
			$data[0]['link'] = $link;
			
			set_transient($this->transientKey, $data, 60*60);
		}
    }
    
    function linkStatsOutput() {
    	$data = get_transient($this->transientKey);
    	if(!$data) { return false; }
    	$clicks = array();
    	foreach($data[0]['clicks'] as $key => $day) {
    		unset($day['day_start'], $day['month'],  $day['week'],  $day['year']);
    		if($key == 0) {
    			$cols = sizeof($day);
    			foreach($day as $k => $d) { 
    				$k = str_replace('_',' ',$k);
    				$k = ucwords($k);
    				$thead .= "<th scope='col'>{$k}</th>";
    			}
    		}
    		$width = round(100/$cols, 2);
    		$tbody .= '<tr>';
	    	foreach($day as $k => $d) { 
	    		if($k == 'clicks') { $clicks[] = $d; }
	    		$tbody .= "<td style='width:{$width}%'>{$d}</td>"; 
	    	}
	    	$tbody .= '</tr>';
    	}
    	$max = 0;
    	foreach($clicks as $click) { if($click > $max) { $max = $click; } }
    	$maxrounded = (round(($max+5)/10))*10;
    	$spread = (floor($data[0]['time'] / 15) > 1) ? floor($data[0]['time'] / 15) : 1;
		
		$charttitle = "Clicks+in+the+last+";
		switch($data[0]['time']) {
			case 7: $charttitle .= 'week'; break;
			case 14: $charttitle .= 'two+weeks'; break;
			case 365: $charttitle .= 'year'; break;
			case 730: $charttitle .= 'two+years'; break;
			case 1095: $charttitle .= 'three+years'; break;
			default: $charttitle .= number_format($data[0]['time']).'+days'; break;
		}
		
    	$downloadlink = '<h2 class="alignright"><a href="'.add_query_arg('transient', $this->transientKey).'" target="_blank">&darr; Download Data as CSV</a></h2>';
    	$chart = '<img width="600" height="300" style="text-align:center; display:block; margin:10px auto;" src="https://chart.googleapis.com/chart?chs=600x300&amp;cht=lc&amp;chxt=x,x,y,y&amp;chxr=0,'.$data[0]['time'].',0,'.$spread.'|2,0,'.$maxrounded.','.(round($maxrounded/10)).'&amp;chxp=1,50|3,50&amp;chxl=1:|Days+from+now|3:|Clicks&amp;chds=-0,'.$max.'&amp;chg=10,-1,1,1&amp;chco=3D7930&amp;chls=1,4,0&amp;chm=B,C5D4B5BB,0,0,0&amp;chtt='.$charttitle.'&amp;chd=t:'.implode(',', array_reverse($clicks)).'" />';
    	
    	$stats = $this->processStats($clicks);
    	
    	if($data[0]['time'] > 800) { $chart = "<p style='text-align:center; padding:10px' class='updated'>Chart not available; too much data!</p>"; }
    	echo $chart.$stats.$downloadlink.'
    	<table class="widefat">
    	<thead>'.$thead.'</thead>
    	<tbody>
    		'.$tbody.'
    	<tbody>
    	</table>';
    }
    function processStats($clicks) {
    	$count = count($clicks);
    	$max = 0;
    	$min = 1000000000000;
    	foreach($clicks as $click) {
    		$sum = $sum + (int)$click;
    		if($min > $click) { $min = $click; }
    		if($max < $click) { $max = $click; }
    	}
    	$avg = round($sum/$count,2);
    	$avg = number_format($avg);
    	$max = number_format($max);
    	$min = number_format($min);
    	$sum = number_format($sum);
    	return "
    	<div class='wrap alignleft'><h3>Stats for this time period:</h3>
    	<ul class='ul-disc'>
    		<li>Total # of Clicks: {$sum}</li>
    		<li>Average # of Clicks: {$avg}</li>
    		<li>Max # of Clicks: {$max}</li>
    		<li>Min # of Clicks: {$min}</li>
    	</ul></div>
    	";
    }
    
    function processDownload() {
    	if(empty($_GET['transient'])) { return; }

    	$data = get_transient($_GET['transient']);
		
		if(!$data) { return false; }
		
		// output up to 5MB is kept in memory, if it becomes bigger
		// it will automatically be written to a temporary file
		$csv = fopen('php://temp/maxmemory:'. (5*1024*1024), 'r+');

		fputcsv($csv, array('clicks', 'timestamp', 'date', 'day of week', 'week', 'month', 'year','days since export'));
		
		foreach ($data[0]['clicks'] as $key => $fields) {
			$fields['id'] = $key;
			fputcsv($csv, $fields);
		}
		
		rewind($csv);

		// put it all in a variable
		$output = stream_get_contents($csv);
		
		$filename = empty($data[0]['user_hash']) ? $data[0]['global_hash'] : $data[0]['user_hash'];
		if(!empty($data[0]['time'])) { $filename .= '-'.(int)$data[0]['time'].'days'; }
		
		header("Content-type: application/octet-stream");
		header("Content-Disposition: attachment; filename=\"{$filename}-bitly-export.csv\"");
		die($output);
    }
    
    function show_configuration_check($link = true) {
    	$options = $this->options;
    	
    	if(!isset($_GET['updated'])) {return; }
    	
        if(!function_exists('curl_init')) { // Added 1.2.2
            $content = __('Your server does not support <code>curl_init</code>. Please call your host and ask them to enable this functionality, which is required for this awesome plugin.', 'bitlyexporter');
            echo $this->make_notice_box($content, 'error');
        } else {
            if($this->configured) {
                $content = __('Your '); if($link) { $content .= '<a href="' . admin_url( 'tools.php?page=bitlyexporter' ) . '">'; } $content .=  __('Bit.ly API settings', 'bitlyexporter'); if($link) { $content .= '</a>'; } $content .= __(' are configured properly');
                echo $this->make_notice_box($content, 'success');
            } else {
                $content = 'Your '; if($link) { $content .= '<a href="' . admin_url( 'tools.php?page=bitlyexporter' ) . '">'; } $content .=  __('Bit.ly API settings', 'bitlyexporter') ; if($link) { $content .= '</a>'; } $content .= '  are <strong>not configured properly.</strong> ';
                $content .= '<br/><br/>Find your API Key settings on <a href="http://bit.ly/a/your_api_key/" target="_blank">http://bit.ly/a/your_api_key/</a>';
                echo $this->make_notice_box($content, 'error');
            };
        }
    }
    
    function settings_link( $links, $file ) {
        static $this_plugin;
        if( ! $this_plugin ) $this_plugin = plugin_basename(__FILE__);
        if ( $file == $this_plugin ) {
            $settings_link = '<a href="' . admin_url( 'tools.php?page=bitlyexporter' ) . '">' . __('Settings', 'bitlyexporter') . '</a>';
            array_unshift( $links, $settings_link ); // before other links
        }
        return $links;
    }
    
    function settings_init() {
        register_setting( 'bitlyexporter_options', 'bitlyexporter', array(&$this, 'sanitize_settings') );
    }
    
    function sanitize_settings($input) {
        return $input;
    }
    
}